package it.unitn.disi.prog2.museoFerroviario;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Label;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class MuseoFerroviario extends Application {
    ViewStage viewStage=new ViewStage();
    Stage controlStage =null;
    final ListOfRotabili lista=new ListOfRotabili(true);

    @Override
    public void start(Stage primaryStage) {
        this.controlStage =primaryStage;
        showControlWindow();
        ViewStage viewStage=new ViewStage();
    }

    boolean isShowStageVisible=false;
    private void showControlWindow() {
        //
        Button showViewButton = new Button();
        showViewButton.setText("Show View");
        showViewButton.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                isShowStageVisible=!isShowStageVisible;
                if (isShowStageVisible) {
                    showViewButton.setText("Hide View");
                    viewStage.show();
                }else{
                    showViewButton.setText("Show View");
                    viewStage.hide();
                }
            }
        });
        //
        Label l1=new Label("Categoria:");
        ChoiceBox choiceBox = new ChoiceBox();
        choiceBox.getItems().add("R - Rotabile");
        choiceBox.getItems().add("M -- Motrice");
        choiceBox.getItems().add("V ---- Locomotiva a Vapore");
        choiceBox.getItems().add("E ---- Locomotore Elettrico");
        choiceBox.getItems().add("T -- Rotabile Trainato");
        choiceBox.getItems().add("P ---- Vagone Passeggeri");
        choiceBox.getItems().add("C ---- Carro Merci");
        choiceBox.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent actionEvent) {
                //int selectedIndex = choiceBox.getSelectionModel().getSelectedIndex();
                String selectedItem = (String)choiceBox.getSelectionModel().getSelectedItem();
                viewStage.setTitle(selectedItem);
                viewStage.setShownType(selectedItem.charAt(0));
                ListOfRotabili selezione=lista.createSublist(selectedItem.charAt(0));
                System.out.println(selezione);
                viewStage.setLista(selezione);
            }
        });

        VBox root = new VBox();
        root.getChildren().addAll(showViewButton,l1,choiceBox);
        Scene scene = new Scene(root, 200, 100);
        scene.setOnKeyTyped(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent keyEvent) {
                String c=keyEvent.getCharacter();
                if (c.equals("D")||c.equals("d")) {
                    viewStage.orderByYear.fireEvent(new ActionEvent());
                } else if (c.equals("N")||c.equals("n")) {
                    viewStage.orderByName.fireEvent(new ActionEvent());
                }
            }
        });
        controlStage.setTitle("Control");
        controlStage.setScene(scene);
        controlStage.setX(10);
        controlStage.setY(10);
        controlStage.show();
    }
    
    public static void main(String[] args) {
        launch(args);
    }
}
